## pypy 1.0.0

=== pypy/lib/logic/gecode_wrapper/Makefile ===


CXXFLAGS=$(shell pkg-config --cflags gecode gecode-minimodel gecode-search) -g
CFLAGS=-g

LDFLAGS=$(shell pkg-config --libs gecode gecode-minimodel gecode-search)

reine: main.o libgecode_wrap.so
	gcc -o reine -L. -lgecode_wrap main.o


libgecode_wrap.so: gecode_wrap.o space_wrap.o gecode_wrap.h space_wrap.hh
	g++ -o $@ $(LDFLAGS) -shared gecode_wrap.o space_wrap.o

## pypy 1.7+dfsg

=== debian/changelog ===
pypy (1.7+dfsg-6) experimental; urgency=low

  * Restrict architectures to linux-any and kfreebsd-any. Not yet ported to
    hurd.
  * Include swap in the RAM calculation on s390*.
  * Forwarded many patches upstream.
  * Drop user-prefix patch, and adjust distutils-install-layout patch and
    package install layout to match.
  * Update manpage, to include environment variables.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 06 Feb 2012 16:50:16 +0200

pypy (1.7+dfsg-5) experimental; urgency=low

  * Revert memory requirement bump. Timeout was unrelated.
  * kfreebsd:
    - Patch plat-gnkfreebsd: Add gnukfreebsd9 platform.
    - Patch kfreebsd-glibc: Adjust platform checks to be aware of the
      difference between gnkfreebsd and freebsd.
    - Patch kfreebsd-test-hangs: Skip tests that deadlock.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 22 Jan 2012 02:20:06 +0200

pypy (1.7+dfsg-4) experimental; urgency=low

  * Really upload to experimental.
  * Patches:
    - big-endian-test_codecs: Add big endian test case to
      test_utf16_encode_decode.
    - big-endian-clibffi: Correctly handle ushort, ubyte, byte, and char types
      in clibffi on big endian.
    - kfreebsd-glibc: Don't attempt to link to libcompat. Link with libdl.
  * Bump memory requirement to 2100 MiB (32-bit), to avoid timeout on
    caballero (4G, ia64).
  * kfreebsd:
    - Enable JIT.
    - Augment, rather than replace, compiler flags from the environment.
  * Don't fail without execstack.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 16 Jan 2012 01:10:27 +0200

pypy (1.7+dfsg-3) experimental; urgency=low

  * Add pypy.1 manpage.
  * Don't BD on greenlet on architectures which it's known not to be ported
    to.
  * Don't BD on execstack on non-linux.
  * Suppress stdlib bytecompilation output.
  * Avoid timeout during build, by running make ourselves. PyPy buffers all
    make output, until it completes.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 14 Jan 2012 17:48:30 +0200

pypy (1.7+dfsg-2) experimental; urgency=low

  * Fix architecture dependant only builds.
  * Remove spurious copyright newline.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 09 Jan 2012 15:52:29 +0200

pypy (1.7+dfsg-1) experimental; urgency=low

  * Re-introduce package in experimental.
  * New upstream version.
  * New packaging:
    - Drop rpython development bits from pypy-dev.
    - Drop pypy-stackless: Now part of the default configuration.
  * Incorporate all useful stdlib patches from python2.7
  * PEP3147 support

 -- Stefano Rivera <stefanor@debian.org>  Mon, 09 Jan 2012 13:32:00 +0200

pypy (1.0.0-svn55443-1) unstable; urgency=low

  * New upstream snapshot.
    - Doesn't hardcode libc6.so.6; fixes FTBFS on ia64 (Closes: #440331)
  * Don't build pypy-stackless on platforms the greenlet module has not been
    ported to. (Closes: #475868)
  * Run tests after build on request by upstream.

 -- Chris Lamb <chris@chris-lamb.co.uk>  Sat, 31 May 2008 18:50:58 +0100

pypy (1.0.0-svn51288-1) unstable; urgency=low

  * New upstream release. (Closes: #459118)
  * New maintainer. (Closes: #455734)
  * Bump debhelper compatibility version.
  * Refresh and tidy package descriptions.
  * Tidy debian/configure.py, debian/rules, Lintian overrides.
  * Add pypy(1), py.py(1), pypy-translate(1), jscompile(1) and
    pypy-stackless(1) manpages.
  * Add get-orig-source target in debian/rules.
  * Use quilt to manage Thiemo Seufer's MIPS and MIPSEL patch.
  * Use PyPy-specific temporary directory prefixes. (Closes: #452851)

 -- Chris Lamb <chris@chris-lamb.co.uk>  Tue, 05 Feb 2008 13:26:11 +0000

pypy (1.0.0-svn51091-1) unstable; urgency=low

  * New upstream svn snapshot, fixing 64bit build (closes: #462008)

 -- Alexandre Fayolle <afayolle@debian.org>  Mon, 28 Jan 2008 09:40:48 +0100

pypy (1.0.0-svn50146-2) unstable; urgency=low

  * Added missing build dependency on zlib1g-dev (closes: #460696)

 -- Alexandre Fayolle <afayolle@debian.org>  Mon, 14 Jan 2008 18:15:32 +0100

pypy (1.0.0-svn50146-1) unstable; urgency=low

  * Acknowledge NMU (closes: #431197)
  * Apply Yaroslav Hachenko's patch to use more recent svn snapshot, and
    enable threading support (closes: #458953)
  * Apply Thiemo Seufer's patch to enable mips and mipsel support
    (closes: #459520)
  * Added build dep on procps (closes: #444652)
  * Bumped up standards to 3.7.3
  * Note that pypy is currently under ITA: I lack time to properly follow
    upstream developments, and all patches and NMU's are welcome. If you'd
    like to adopt pypy, just send me an email to notify me and jump for
    it. Offers to co-maintain are welcome too. Thanks.

 -- Alexandre Fayolle <afayolle@debian.org>  Mon, 14 Jan 2008 09:46:11 +0100

pypy (1.0.0-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Disable build of upstream removed logic object space. Remove pypy-logic
    package. (closes: #442060)
  * Move build output away from /tmp. (closes: #452850)
  * Move compile step out of the main translation. This reduces the memory
    footprint by one third.

 -- Bastian Blank <waldi@debian.org>  Tue, 27 Nov 2007 12:08:06 +0000

pypy (1.0.0-3) unstable; urgency=low

  * Use more conservative options for platforms for which support is uncertain
  * Enable check of available memory during configuration
  * Packages are once again arch: any

 -- Alexandre.Fayolle <afayolle@debian.org>  Wed, 18 Jul 2007 12:57:28 +0200

pypy (1.0.0-2) unstable; urgency=low

  * Updated debian/copyright (Closes: #423603)
  * Removed support for archs not supported upstream (Closes: #426265, #423725)
  * Adds missing conftest.py (Closes: #428539)

 -- Alexandre.Fayolle <afayolle@debian.org>  Thu, 28 Jun 2007 12:25:53 +0200

pypy (1.0.0-1) unstable; urgency=low

  * Fixed debian/copyright and reupload (Closes: #326892)
  * New upstream release

 -- Alexandre Fayolle <afayolle@debian.org>  Fri, 13 Apr 2007 09:33:09 +0200

pypy (0.99.0-1) experimental; urgency=low

  * Initial release (Closes: #326892)



=== debian/control ===
Source: pypy
Section: python
Priority: extra
Maintainer: Stefano Rivera <stefanor@debian.org>
Build-Depends:
 debhelper (>= 8.9.7~),
 execstack [linux-any],
 libbz2-dev,
 libexpat1-dev,
 libffi-dev,
 libncurses-dev,
 libssl-dev,
 pkg-config,
 python2.7-dev,
 python-docutils,
 python-greenlet [!alpha !ia64 !sparc !sparc64],
 python-sphinx (>= 1.0.7+dfsg),
 valgrind [amd64 armel armhf i386 powerpc],
 zlib1g-dev
Build-Depends-Indep: graphviz
Standards-Version: 3.9.2
Homepage: http://pypy.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/pypy.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pypy.git

Package: pypy
Architecture: linux-any kfreebsd-any
Depends: ${misc:Depends}, ${shlibs:Depends}, pypy-lib (= ${source:Version})
Breaks: pypy-dev (<< ${source:Version})
Suggests: pypy-doc
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: fast alternative implementation of Python - PyPy interpreter
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7). It has several advantages and distinct features:
 Speed: thanks to its Just-in-Time compiler (on x86), Python programs often run
 faster on PyPy.
 Memory usage: large, memory-hungry Python programs might end up taking less
 space than they do in CPython.
 Compatibility: PyPy is highly compatible with existing Python code. It
 supports ctypes and can run popular Python libraries like twisted and django.
 Stackless: PyPy can be configured to run in stackless mode, providing
 micro-threads for massive concurrency.
 .
 This package contains the PyPy interpreter.

Package: pypy-lib
Architecture: all
Depends: ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: Standard library for PyPy (an alternative Python interpreter)
 The PyPy standard library. This is a combination of modules, copied directly
 from cpython, modified cpython modules, and modules entirely re-implemented
 (usually in pure Python, where they are C extensions in cpython).
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Suggests: python-doc
Description: Developer Documentation for PyPy (an alternative Python interpreter)
 The Developer documentation for PyPy. This mostly covers the internals of
 PyPy, and development of PyPy itself.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-dev
Architecture: all
Depends: ${misc:Depends}, pypy (>= ${source:Version})
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: Header files for PyPy (an alternative Python interpreter)
 Header files for compiling cpython C extension modules for use with PyPy.
 Note that pure Python modules will probably perform better.
 .
 PyPy supports a subset of cpython's C API through its CPyExt subsystem.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

=== debian/rules ===
#!/usr/bin/make -f

PYTHON=python2.7
# Take advantage of PyPy if it's installed
#PYTHON=$(shell command -v pypy > /dev/null && echo pypy || echo python2.7)

# PyPy doesn't harden well, and handles opt and debug itself
BUILDFLAGS_ENV := DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-fortify
BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O0 -O1 -O2 -O3 -Os -Ofast -g"
export CFLAGS := $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
export LDFLAGS := $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

export PYPY_USESSION_BASENAME := debian

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
  OPT := 0
else
  OPT := $(shell dpkg-architecture -iany-i386 || dpkg-architecture -iany-amd64 && echo jit || echo 3)
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  SUB_MAKEFLAGS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

%:
	dh $@ --with sphinxdoc --without python-support

override_dh_auto_configure:
	set -e; \
	mem=$(shell sed -rne 's/^MemTotal: *([0-9]+) kB$$/\1/p' /proc/meminfo); \
	dpkg-architecture -qDEB_BUILD_ARCH | grep -q s390 \
		&& mem=$$(($$mem + $(shell sed -rne 's/^SwapTotal: *([0-9]+) kB$$/\1/p' /proc/meminfo))) || true; \
	req_mem=1900; \
	bits=$(shell dpkg-architecture -qDEB_HOST_ARCH_BITS); \
	[ $$bits -ge 64 ] && req_mem=$$(($$req_mem * 2)) || true; \
	if [ $$(($$req_mem * 1024)) -gt $$mem ]; then \
		echo "You don't have enough RAM to build PyPy."; \
		echo "It's known to require >= $$req_mem MiB on $$bits bit archs."; \
		exit 1; \
	fi

override_dh_auto_build-arch: export TMPDIR = $(CURDIR)/build-tmp
override_dh_auto_build-arch: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
override_dh_auto_build-arch:
	rm -rf $(TMPDIR)
	mkdir $(TMPDIR)
	cd pypy/translator/goal && $(PYTHON) translate.py --batch --opt=$(OPT) \
	                                     --source targetpypystandalone
	# PyPy captures all make output, so we call it ourselves, to avoid timeouts:
	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
	cp $(C_SRC_DIR)/pypy-c pypy/translator/goal

	# https://bugs.pypy.org/issue610:
	if [ -x /usr/sbin/execstack ]; then \
		/usr/sbin/execstack --clear-execstack pypy/translator/goal/pypy-c; \
	fi
	rst2man debian/pypy.1.rst > build-tmp/pypy.1

override_dh_auto_build-indep:
	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test: export TMPDIR = $(CURDIR)/build-tests-tmp
override_dh_auto_test: export HOME = $(TMPDIR)
override_dh_auto_test:
	rm -rf $(TMPDIR) build-tests
	mkdir $(TMPDIR) build-tests
	# Test failures currently ignored
	PYTHONPATH=. $(PYTHON) testrunner/runner.py \
	                       --logfile=build-tests/pytest-A.log \
	                       --config=pypy/pytest-A.cfg \
	                       --root=pypy || true
	$(PYTHON) pypy/test_all.py \
	          --pypy=pypy/translator/goal/pypy-c \
	          --resultlog=build-tests/lib-python.log \
	          lib-python || true
	pypy/translator/goal/pypy-c pypy/test_all.py \
	       --resultlog=build-tests/pypy-c.log \
	       pypy/module/pypyjit/test_pypy_c || true
endif

override_dh_auto_install:
	# Upstream provides no install script

override_dh_auto_clean:
	rm -rf build-*
	# Created by our PEP3147 patch:
	rm -f pypy/doc/config/objspace.magic_tag.txt
	find . -name '*.pyc' -delete
	rm -f pypy/translator/goal/pypy-c
	rm -f pypy/translator/cli/src/*.exe pypy/translator/cli/src/*.dll
	rm -f include/*.h include/*.inl
	rm -rf pypy/_cache
	rm -f lib_pypy/ctypes_config_cache/_*_cache.py
	rm -f $(filter-out %__init__.py, $(wildcard lib_pypy/ctypes_config_cache/_*_.py))
	rm -f lib-python/modified-2.7/lib2to3/*Grammar*.pickle \
	      pypy/module/test_lib_pypy/ctypes_tests/_ctypes_test.o \
	      pypy/doc/config/commandline*.rst \
	      pypy/doc/config/objspace*.rst \
	      pypy/doc/config/translation*.rst

override_dh_install-arch:
	dh_install -a
	# __init__.py gets included in our glob for architecture-dependant bits of
	# the stdlib
	rm -f debian/pypy/usr/lib/pypy/lib_pypy/ctypes_config_cache/__init__.py

override_dh_install-indep:
	dh_install -i
	# Architecture-dependant bits of the stdlib (shipped in pypy)
	find debian/pypy-lib/usr/lib/pypy/lib_pypy/ctypes_config_cache \
	     \( -name '_*_.py' -a ! -name '__init__.py' \) -delete
	# Architecture-dependant headers (shipped in pypy)
	rm debian/pypy-dev/usr/lib/pypy/include/pypy_*.h

override_dh_fixperms-indep:
	find debian/pypy-lib -name '*.pyc' -delete
	find debian/pypy-lib -name '__pycache__' -delete
	# Don't need these, and lintian will make a noise about them
	find debian/pypy-lib \( -name 'regen' -o -name '*.bat' -o -name 'fetch_*' \) -delete
	# Remove empty directories, because bytecompile-stdlib will
	find debian/pypy-lib/usr/lib/pypy/lib-python -type d -empty -delete
	# Nothing in the stdlib should be executable
	chmod -R a-x+X debian/pypy-lib/usr/lib/pypy/lib*
	# Fix interpreters
	find debian/pypy-lib -name '*.py' -print0 | xargs -0 sed -i -e '1s|^#!.*python.*|#!/usr/bin/pypy|'
	dh_fixperms -i

override_dh_sphinxdoc-arch:
	# dh_sphinxdoc doesn't fail silently when there are no docs

override_dh_compress:
	dh_compress -X.inv -X.txt

override_dh_builddeb:
	dh_builddeb -- -Zxz

HG_REPO ?= https://bitbucket.org/pypy/pypy
REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
get-packaged-orig-source:
	@echo "You can build this from a local repo by supplying the HG_REPO variable"
	rm -rf pypy-$(VER).orig
	hg clone $(HG_REPO) pypy-$(VER).orig
ifeq (,$(REV))
	cd pypy-$(VER).orig && hg up -r release-$(VER)
else
	cd pypy-$(VER).orig && hg up -r $(REV)
endif
	rm -rf pypy-$(VER).orig/.hg*
	rm pypy-$(VER).orig/lib-python/*2.7/distutils/command/*.exe
	rm pypy-$(VER).orig/pypy/translator/jvm/src/*.jar
	tar -cJ --owner root --group root --mode a+rX \
	    -f pypy_$(VER)+dfsg.orig.tar.xz pypy-$(VER).orig
	rm -rf pypy-$(VER).orig

## pypy 1.8+dfsg

=== debian/changelog ===
pypy (1.8+dfsg-2) experimental; urgency=low

  * Build the sandboxed PyPy with -O2, not -O3 or -Ojit.  Sandboxed pypy can't
    be built with profile-guided optimisations.
    - Use generational gc, now that we aren't using the JIT.
  * Patch gnukfreebsd-link-rt: Link with -lrt on GNU/kFreeBSD.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 18 Feb 2012 09:28:14 +0200

pypy (1.8+dfsg-1) experimental; urgency=low

  * New upstream release.
  * Refresh patches.
  * Drop patches, applied upstream:
    - compiler-flags
    - docs-version
    - hardcoded-nursery-size
    - test_ssl-errno0
    - test_unix_socket_connect
    - big-endian-test_codecs
    - big-endian-clibffi
    - kfreebsd-glibc
    - kfreebsd-test-hangs
  * Build manpage from upstream docs.
  * Patch doc-envvars: Update manpage, to include environment variables.
  * Patch fpic-archs: Build shared libraries with -fPIC on arm and mips.
  * Patch pypy-help: Make --help not crash.
  * Update copyright contributors and years.
  * pep3147-core: Assert the absence of nulls (assert_str0) on the pathnames
    provided in make_compiled_pathname and make_source_pathname.
  * Build sandboxed pypy: python-pypy.translator.sandbox
    - Patch ignore-shufps: Fix build failure.
    - Patch sandbox-bin: Change pypy_interact's --help to name it pypy-sandbox
    - Patch sandbox-dependencies: Reduce the amount of pypy source that
      pypy-sandobx needs.
    - Patch sandbox-manpage: pypy-sandbox manpage.
    - B-D on python (>= 2.6.6-11~) for dh_python2 with .pyinstall support.
  * Run translations and tests with unbuffered I/O, to combat build timeouts.
    - Lower build-time RAM requirement to 1.4G.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 14 Feb 2012 15:10:21 +0200

=== debian/control ===
--- 
+++ 
@@ -11,10 +11,11 @@
  libncurses-dev,
  libssl-dev,
  pkg-config,
- python2.7-dev,
+ python (>= 2.6.6-11~),
  python-docutils,
  python-greenlet [!alpha !ia64 !sparc !sparc64],
  python-sphinx (>= 1.0.7+dfsg),
+ python2.7-dev,
  valgrind [amd64 armel armhf i386 powerpc],
  zlib1g-dev
 Build-Depends-Indep: graphviz
@@ -24,8 +25,8 @@
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pypy.git
 
 Package: pypy
-Architecture: linux-any kfreebsd-any
-Depends: ${misc:Depends}, ${shlibs:Depends}, pypy-lib (= ${source:Version})
+Architecture: kfreebsd-any linux-any
+Depends: pypy-lib (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
 Breaks: pypy-dev (<< ${source:Version})
 Suggests: pypy-doc
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
@@ -43,11 +44,29 @@
  .
  This package contains the PyPy interpreter.
 
+Package: python-pypy.translator.sandbox
+Architecture: kfreebsd-any linux-any
+Depends:
+ pypy-lib (= ${source:Version}),
+ ${misc:Depends},
+ ${python:Depends},
+ ${shlibs:Depends}
+Suggests: python-py
+Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
+Description: sandboxed PyPy interpreter
+ A version of PyPy that runs fully "virtualized", where an external process
+ controls all input/output. This is a secure sandbox, it is safe to run any
+ untrusted Python code with it. The Python code cannot see or modify any local
+ file except via interaction with the external process.
+ .
+ PyPy is a fast, compliant alternative implementation of the Python language
+ (2.7).
+
 Package: pypy-lib
 Architecture: all
 Depends: ${misc:Depends}
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
-Description: Standard library for PyPy (an alternative Python interpreter)
+Description: standard library for PyPy (an alternative Python interpreter)
  The PyPy standard library. This is a combination of modules, copied directly
  from cpython, modified cpython modules, and modules entirely re-implemented
  (usually in pure Python, where they are C extensions in cpython).
@@ -61,7 +80,7 @@
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Suggests: python-doc
-Description: Developer Documentation for PyPy (an alternative Python interpreter)
+Description: developer Documentation for PyPy (an alternative Python interpreter)
  The Developer documentation for PyPy. This mostly covers the internals of
  PyPy, and development of PyPy itself.
  .
@@ -70,9 +89,9 @@
 
 Package: pypy-dev
 Architecture: all
-Depends: ${misc:Depends}, pypy (>= ${source:Version})
+Depends: pypy (>= ${source:Version}), ${misc:Depends}
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
-Description: Header files for PyPy (an alternative Python interpreter)
+Description: header files for PyPy (an alternative Python interpreter)
  Header files for compiling cpython C extension modules for use with PyPy.
  Note that pure Python modules will probably perform better.
  .

=== debian/rules ===
--- 
+++ 
@@ -14,23 +14,26 @@
 
 ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
   OPT := 0
+  SANDBOX_OPT := 0
 else
   OPT := $(shell dpkg-architecture -iany-i386 || dpkg-architecture -iany-amd64 && echo jit || echo 3)
+  SANDBOX_OPT := 2
 endif
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
   SUB_MAKEFLAGS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 endif
 
+# dh_python2 is used for pypy-sandbox
 %:
-	dh $@ --with sphinxdoc --without python-support
+	dh $@ --with python2,sphinxdoc
 
 override_dh_auto_configure:
 	set -e; \
 	mem=$(shell sed -rne 's/^MemTotal: *([0-9]+) kB$$/\1/p' /proc/meminfo); \
 	dpkg-architecture -qDEB_BUILD_ARCH | grep -q s390 \
 		&& mem=$$(($$mem + $(shell sed -rne 's/^SwapTotal: *([0-9]+) kB$$/\1/p' /proc/meminfo))) || true; \
-	req_mem=1900; \
+	req_mem=1400; \
 	bits=$(shell dpkg-architecture -qDEB_HOST_ARCH_BITS); \
 	[ $$bits -ge 64 ] && req_mem=$$(($$req_mem * 2)) || true; \
 	if [ $$(($$req_mem * 1024)) -gt $$mem ]; then \
@@ -44,17 +47,31 @@
 override_dh_auto_build-arch:
 	rm -rf $(TMPDIR)
 	mkdir $(TMPDIR)
-	cd pypy/translator/goal && $(PYTHON) translate.py --batch --opt=$(OPT) \
+	cd pypy/translator/goal && $(PYTHON) -u translate.py --batch --opt=$(OPT) \
 	                                     --source targetpypystandalone
 	# PyPy captures all make output, so we call it ourselves, to avoid timeouts:
 	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
 	cp $(C_SRC_DIR)/pypy-c pypy/translator/goal
 
+	# Sandboxed translation:
+	rm -rf $(TMPDIR)
+	mkdir $(TMPDIR)
+	cd pypy/translator/goal && $(PYTHON) -u translate.py --batch \
+	                                     --opt=$(SANDBOX_OPT) \
+	                                     --sandbox \
+	                                     --gc=generation \
+	                                     --gcrootfinder=shadowstack \
+	                                     --source targetpypystandalone
+	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
+	cp $(C_SRC_DIR)/pypy-c pypy/translator/goal/pypy-c-sandbox
+	rm -rf $(TMPDIR)
+
 	# https://bugs.pypy.org/issue610:
 	if [ -x /usr/sbin/execstack ]; then \
 		/usr/sbin/execstack --clear-execstack pypy/translator/goal/pypy-c; \
+		/usr/sbin/execstack --clear-execstack pypy/translator/goal/pypy-c-sandbox; \
 	fi
-	rst2man debian/pypy.1.rst > build-tmp/pypy.1
+	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
@@ -66,15 +83,15 @@
 	rm -rf $(TMPDIR) build-tests
 	mkdir $(TMPDIR) build-tests
 	# Test failures currently ignored
-	PYTHONPATH=. $(PYTHON) testrunner/runner.py \
+	PYTHONPATH=. $(PYTHON) -u testrunner/runner.py \
 	                       --logfile=build-tests/pytest-A.log \
 	                       --config=pypy/pytest-A.cfg \
 	                       --root=pypy || true
-	$(PYTHON) pypy/test_all.py \
+	$(PYTHON) -u pypy/test_all.py \
 	          --pypy=pypy/translator/goal/pypy-c \
 	          --resultlog=build-tests/lib-python.log \
 	          lib-python || true
-	pypy/translator/goal/pypy-c pypy/test_all.py \
+	pypy/translator/goal/pypy-c -u pypy/test_all.py \
 	       --resultlog=build-tests/pypy-c.log \
 	       pypy/module/pypyjit/test_pypy_c || true
 endif
@@ -87,7 +104,7 @@
 	# Created by our PEP3147 patch:
 	rm -f pypy/doc/config/objspace.magic_tag.txt
 	find . -name '*.pyc' -delete
-	rm -f pypy/translator/goal/pypy-c
+	rm -f pypy/translator/goal/pypy-c*
 	rm -f pypy/translator/cli/src/*.exe pypy/translator/cli/src/*.dll
 	rm -f include/*.h include/*.inl
 	rm -rf pypy/_cache
@@ -132,6 +149,9 @@
 override_dh_compress:
 	dh_compress -X.inv -X.txt
 
+override_dh_python2:
+	dh_python2 -p python-pypy.translator.sandbox
+
 override_dh_builddeb:
 	dh_builddeb -- -Zxz

## pypy 1.9+dfsg

=== pypy/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  man       to make manual pages"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	python config/generate.py
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	python config/generate.py
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	python config/generate.py
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	python config/generate.py
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	python config/generate.py
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	python config/generate.py
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PyPy.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PyPy.qhc"

latex:
	python config/generate.py
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

man:
	python config/generate.py
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man"

changes:
	python config/generate.py
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	python config/generate.py
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	python config/generate.py
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== pypy/translator/c/src/stacklet/Makefile ===

all: stacklet.so

stacklet.so: stacklet.c stacklet.h
	gcc -fPIC -shared -O2 -o $@ stacklet.c

stacklet_g.so: stacklet.c stacklet.h
	gcc -fPIC -shared -g -o $@ stacklet.c -DDEBUG_DUMP

clean:
	rm -fr stacklet.so stacklet_g.so
	rm -fr run_tests_*_[go]


DEBUG = -DDEBUG_DUMP

tests: clean
	make -j1 run-all-tests

ALL_TESTS = tests-static-g \
            tests-static-o \
            tests-dynamic-g \
            tests-dynamic-o

run-all-tests: $(ALL_TESTS)
	@echo "*** All test suites passed ***"

tests-static-g: stacklet.c stacklet.h tests.c
	gcc -Wall -g -o run_tests_static_g stacklet.c tests.c ${DEBUG}
	run_tests_static_g

tests-static-o: stacklet.c stacklet.h tests.c
	gcc -Wall -g -O2 -o run_tests_static_o stacklet.c tests.c ${DEBUG}
	run_tests_static_o

tests-dynamic-g: stacklet_g.so tests.c
	gcc -Wall -g -o run_tests_dynamic_g stacklet_g.so tests.c ${DEBUG}
	LD_LIBRARY_PATH=. run_tests_dynamic_g

tests-dynamic-o: stacklet.so tests.c
	gcc -Wall -g -O2 -o run_tests_dynamic_o stacklet.so tests.c ${DEBUG}
	LD_LIBRARY_PATH=. run_tests_dynamic_o

tests-repeat: tests
	python runtests.py run_tests_static_g > /dev/null
	python runtests.py run_tests_static_o > /dev/null
	LD_LIBRARY_PATH=. python runtests.py run_tests_dynamic_g > /dev/null
	LD_LIBRARY_PATH=. python runtests.py run_tests_dynamic_o > /dev/null
	@echo "*** All tests passed repeatedly ***"

=== debian/changelog ===
pypy (1.9+dfsg-1) experimental; urgency=low

  * New upstream release.
  * Refresh patches.
  * Update patches for the removal of lib-python/modified-2.7.
  * Drop patches, applied upstream:
    - ignore-shufps
    - pypy-help
  * Apply patches applied in python2.7 2.7.3~rc2-2:
    - pypirc-secure: CVE-2011-4944, distutils creates ~/.pypirc insecurely.
    - xdg-gvfs-open: Use xdg-open/gvfs-open in webbrowser.
  * Moved RAM check and translation options generation into shell scripts in
    debian/scripts. They were getting unwieldy in debian/rules.
  * Updated machine-readable copyright Format to 1.0.
    - Removed mentions of lib-python/modified-2.7.
  * Bumped Standards-Version to 3.9.3, no changes needed.
  * Use valgrind headers on ppc64 and s390x, now that they are available
    there.
  * Don't enforce the RAM check on Ubuntu.
  * Patch ignore-paddd: Update ignored operations ins trackinggcroot our
    gcc4.7 produces paddd on i386.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 19 Jun 2012 14:42:45 +0200

=== debian/control ===
--- 
+++ 
@@ -16,10 +16,10 @@
  python-greenlet [!alpha !ia64 !sparc !sparc64],
  python-sphinx (>= 1.0.7+dfsg),
  python2.7-dev,
- valgrind [amd64 armel armhf i386 powerpc],
+ valgrind [amd64 armel armhf i386 powerpc ppc64 s390x],
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://pypy.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/pypy.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pypy.git

=== debian/rules ===
--- 
+++ 
@@ -7,18 +7,10 @@
 # PyPy doesn't harden well, and handles opt and debug itself
 BUILDFLAGS_ENV := DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-fortify
 BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O0 -O1 -O2 -O3 -Os -Ofast -g"
-export CFLAGS := $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
-export LDFLAGS := $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)
+export CFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
+export LDFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)
 
 export PYPY_USESSION_BASENAME := debian
-
-ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
-  OPT := 0
-  SANDBOX_OPT := 0
-else
-  OPT := $(shell dpkg-architecture -iany-i386 || dpkg-architecture -iany-amd64 && echo jit || echo 3)
-  SANDBOX_OPT := 2
-endif
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
   SUB_MAKEFLAGS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -29,52 +21,28 @@
 	dh $@ --with python2,sphinxdoc
 
 override_dh_auto_configure:
-	set -e; \
-	mem=$(shell sed -rne 's/^MemTotal: *([0-9]+) kB$$/\1/p' /proc/meminfo); \
-	dpkg-architecture -qDEB_BUILD_ARCH | grep -q s390 \
-		&& mem=$$(($$mem + $(shell sed -rne 's/^SwapTotal: *([0-9]+) kB$$/\1/p' /proc/meminfo))) || true; \
-	req_mem=1400; \
-	bits=$(shell dpkg-architecture -qDEB_HOST_ARCH_BITS); \
-	[ $$bits -ge 64 ] && req_mem=$$(($$req_mem * 2)) || true; \
-	if [ $$(($$req_mem * 1024)) -gt $$mem ]; then \
-		echo "You don't have enough RAM to build PyPy."; \
-		echo "It's known to require >= $$req_mem MiB on $$bits bit archs."; \
-		exit 1; \
-	fi
+	debian/scripts/memory-check.sh
 
-override_dh_auto_build-arch: export TMPDIR = $(CURDIR)/build-tmp
-override_dh_auto_build-arch: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
-override_dh_auto_build-arch:
-	rm -rf $(TMPDIR)
-	mkdir $(TMPDIR)
-	cd pypy/translator/goal && $(PYTHON) -u translate.py --batch --opt=$(OPT) \
-	                                     --source targetpypystandalone
-	# PyPy captures all make output, so we call it ourselves, to avoid timeouts:
-	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
-	cp $(C_SRC_DIR)/pypy-c pypy/translator/goal
-
-	# Sandboxed translation:
-	rm -rf $(TMPDIR)
-	mkdir $(TMPDIR)
-	cd pypy/translator/goal && $(PYTHON) -u translate.py --batch \
-	                                     --opt=$(SANDBOX_OPT) \
-	                                     --sandbox \
-	                                     --gc=generation \
-	                                     --gcrootfinder=shadowstack \
-	                                     --source targetpypystandalone
-	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
-	cp $(C_SRC_DIR)/pypy-c pypy/translator/goal/pypy-c-sandbox
-	rm -rf $(TMPDIR)
-
-	# https://bugs.pypy.org/issue610:
-	if [ -x /usr/sbin/execstack ]; then \
-		/usr/sbin/execstack --clear-execstack pypy/translator/goal/pypy-c; \
-		/usr/sbin/execstack --clear-execstack pypy/translator/goal/pypy-c-sandbox; \
-	fi
+override_dh_auto_build-arch: pypy/translator/goal/pypy-c pypy/translator/goal/pypy-c-sandbox
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
+
+pypy/translator/goal/pypy-%: export TMPDIR = $(CURDIR)/build-tmp
+pypy/translator/goal/pypy-%: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
+pypy/translator/goal/pypy-%:
+	rm -rf $(TMPDIR)
+	mkdir $(TMPDIR)
+	debian/scripts/translate.sh --python $(PYTHON) $$(echo $@ | grep -q sandbox && echo --sandbox)
+	# PyPy captures all make output, so we call it ourselves, to avoid timeouts:
+	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
+	cp $(C_SRC_DIR)/pypy-c $@
+
+	# https://bugs.pypy.org/issue610:
+	if [ -x /usr/sbin/execstack ]; then \
+		/usr/sbin/execstack --clear-execstack $@; \
+	fi
 
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test: export TMPDIR = $(CURDIR)/build-tests-tmp
@@ -110,7 +78,7 @@
 	rm -rf pypy/_cache
 	rm -f lib_pypy/ctypes_config_cache/_*_cache.py
 	rm -f $(filter-out %__init__.py, $(wildcard lib_pypy/ctypes_config_cache/_*_.py))
-	rm -f lib-python/modified-2.7/lib2to3/*Grammar*.pickle \
+	rm -f lib-python/2.7/lib2to3/*Grammar*.pickle \
 	      pypy/module/test_lib_pypy/ctypes_tests/_ctypes_test.o \
 	      pypy/doc/config/commandline*.rst \
 	      pypy/doc/config/objspace*.rst \

## pypy 2.0.2+dfsg

=== Makefile ===

all: pypy-c

pypy-c:
	@echo "Building PyPy with JIT, it'll take about 40 minutes and 4G of RAM"
	@sleep 3
	rpython/bin/rpython -Ojit pypy/goal/targetpypystandalone.py

=== debian/changelog ===
pypy (2.0.2+dfsg-4) unstable; urgency=low

  * Relax the RAM check on kfreebsd-amd64, which currently has 3GB buildds.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 28 Jun 2013 01:12:07 +0200

pypy (2.0.2+dfsg-3) unstable; urgency=low

  * Let dh_usrlocal handle the empty directories in /usr/local, and create
    them with dh_installdirs. (Closes: #713958)
  * Use a more conservative RAM requirement on x86. (Closes: #713787)

 -- Stefano Rivera <stefanor@debian.org>  Mon, 24 Jun 2013 18:44:22 +0200

pypy (2.0.2+dfsg-2) unstable; urgency=low

  * Create empty directories in /usr/local
  * Fix a bug in l2-cache-detection on sparc, causing FTBFS due to the
    interpreter aborting on startup.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 23 Jun 2013 23:07:54 +0200

pypy (2.0.2+dfsg-1) unstable; urgency=low

  * New upstream bug-fix release.
    - mainly fatal errors or crashes in the stdlib, and a JIT bug around
      foreign functions calls in multi-threaded programs.
  * Refresh patches.
  * Drop docs-version patch.
  * Clean up after cffi tests.
  * so_reuseport: Avoid test failures on machines without SO_REUSEPORT
    support.
  * gnukfreebsd: Add the GNUkFreebsd platform descriptions that were
    accidentally deleted upstream.
  * Drop B-D on python-greenlet, unneeded.
  * l2-cache-detection: Add L2 cache size detection code for non-x86
    architectures.
  * Bullet pypy's description to make it more readable. Thanks Jonas
    Smedegaard. (Closes: #709091)
  * Disable ARM JIT until declared stable by upstream.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 24 May 2013 01:08:28 +0200

pypy (2.0.0+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #698524)
  * Upload to unstable.
  * Refresh patches.
  * Update copyright.
  * Drop patches, applied/superseded upstream:
    - test_telnetlib-deadlock
    - test_subprocess
    - ignore-paddd
    - issue670664
    - fpic-archs
    - gnukfreebsd-link-rt
  * Patches:
    - pep3147-core: Drop validation of .py filenames. This is behaviour is now
      expected in tests.
    - pep3147-stdlib: Use cached_from_source in added tests.
    - distutils-install-layout: Let pydoc handle dist-packages the same as
      site-packages.
    - shared-ffi: Don't static link with libffi.
    - docs-version: Update docs versions for 2.0 final.
    - distutils-cflags: Build cffi modules when CFLAGS contains a space.
  * Export TERM=dumb for lib-python tests (if not already in the environment).
    Required by test_readline.
  * Build-Depend on procps, for test_signal.
  * Build-Depend on netbase, for test_socket.
  * Build-Depend on libsqlite3-dev, _sqlite3 (which now uses CFFI).
  * Build with JIT on ARM.
  * Use valgrind headers on mips, now that they are available there.
  * Update paths for the rpython-pypy split.
  * Rename python-pypy.translator.sandbox -> python-pypy.sandbox, following
    the pypy-rpython split.
  * cffi is now bundled in the stdlib:
    - Move _cffi shared libraries out of __pycache__, and put them in the
      pypy binary package.
    - Provides pypy-cffi.
  * Byte-compile lib_pypy, too.
  * Bumped Standards-Version to 3.9.4, no changes needed.
  * Build-Depend on python-greenlet, enabling stackless builds on, sparc and
    sparc64, now that it's available there. Blacklist sh4.
  * Use valgrind headers on mipsel, now that they are available.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 10 May 2013 20:15:26 +0200

pypy (1.9+dfsg-2) experimental; urgency=low

  * Redirect translation output to stdout. Buildds don't watch stderr for
    checking timeouts.
  * Do enforce the RAM check on Ubuntu, for non-primary-archive builds.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 12 Jul 2012 21:51:31 -0600

=== debian/control ===
--- 
+++ 
@@ -9,17 +9,19 @@
  libexpat1-dev,
  libffi-dev,
  libncurses-dev,
+ libsqlite3-dev,
  libssl-dev,
+ netbase,
  pkg-config,
+ procps,
  python (>= 2.6.6-11~),
  python-docutils,
- python-greenlet [!alpha !ia64 !sparc !sparc64],
  python-sphinx (>= 1.0.7+dfsg),
  python2.7-dev,
- valgrind [amd64 armel armhf i386 powerpc ppc64 s390x],
+ valgrind [amd64 armel armhf i386 mips mipsel powerpc ppc64 s390x],
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://pypy.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/pypy.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pypy.git
@@ -33,18 +35,19 @@
 Description: fast alternative implementation of Python - PyPy interpreter
  PyPy is a fast, compliant alternative implementation of the Python language
  (2.7). It has several advantages and distinct features:
- Speed: thanks to its Just-in-Time compiler (on x86), Python programs often run
- faster on PyPy.
- Memory usage: large, memory-hungry Python programs might end up taking less
- space than they do in CPython.
- Compatibility: PyPy is highly compatible with existing Python code. It
- supports ctypes and can run popular Python libraries like twisted and django.
- Stackless: PyPy can be configured to run in stackless mode, providing
- micro-threads for massive concurrency.
+  * Speed: thanks to its Just-in-Time compiler (on x86), Python programs often
+    run faster on PyPy.
+  * Memory usage: large, memory-hungry Python programs might end up taking less
+    space than they do in CPython.
+  * Compatibility: PyPy is highly compatible with existing Python code.
+    It supports ctypes and can run popular Python libraries like twisted and
+    django.
+  * Stackless: PyPy supports stackless mode on x86, providing
+    micro-threads for massive concurrency.
  .
  This package contains the PyPy interpreter.
 
-Package: python-pypy.translator.sandbox
+Package: python-pypy.sandbox
 Architecture: kfreebsd-any linux-any
 Depends:
  pypy-lib (= ${source:Version}),
@@ -52,6 +55,8 @@
  ${python:Depends},
  ${shlibs:Depends}
 Suggests: python-py
+Replaces: python-pypy.translator.sandbox (<< 2.0~beta2+hg61648)
+Breaks: python-pypy.translator.sandbox (<< 2.0~beta2+hg61648)
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Description: sandboxed PyPy interpreter
  A version of PyPy that runs fully "virtualized", where an external process
@@ -66,6 +71,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
+Provides: pypy-cffi
 Description: standard library for PyPy (an alternative Python interpreter)
  The PyPy standard library. This is a combination of modules, copied directly
  from cpython, modified cpython modules, and modules entirely re-implemented

=== debian/rules ===
--- 
+++ 
@@ -23,15 +23,17 @@
 override_dh_auto_configure:
 	debian/scripts/memory-check.sh
 
-override_dh_auto_build-arch: pypy/translator/goal/pypy-c pypy/translator/goal/pypy-c-sandbox
+override_dh_auto_build-arch: pypy/goal/pypy-c pypy/goal/pypy-c-sandbox
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
+	# Build cffi modules
+	pypy/goal/pypy-c -c 'import _sqlite3, _curses'
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
 
-pypy/translator/goal/pypy-%: export TMPDIR = $(CURDIR)/build-tmp
-pypy/translator/goal/pypy-%: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
-pypy/translator/goal/pypy-%:
+pypy/goal/pypy-%: export TMPDIR = $(CURDIR)/build-tmp
+pypy/goal/pypy-%: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
+pypy/goal/pypy-%:
 	rm -rf $(TMPDIR)
 	mkdir $(TMPDIR)
 	debian/scripts/translate.sh --python $(PYTHON) $$(echo $@ | grep -q sandbox && echo --sandbox)
@@ -55,11 +57,11 @@
 	                       --logfile=build-tests/pytest-A.log \
 	                       --config=pypy/pytest-A.cfg \
 	                       --root=pypy || true
-	$(PYTHON) -u pypy/test_all.py \
-	          --pypy=pypy/translator/goal/pypy-c \
+	TERM=$${TERM:-dumb} $(PYTHON) -u pypy/test_all.py \
+	          --pypy=pypy/goal/pypy-c \
 	          --resultlog=build-tests/lib-python.log \
 	          lib-python || true
-	pypy/translator/goal/pypy-c -u pypy/test_all.py \
+	pypy/goal/pypy-c -u pypy/test_all.py \
 	       --resultlog=build-tests/pypy-c.log \
 	       pypy/module/pypyjit/test_pypy_c || true
 endif
@@ -72,12 +74,19 @@
 	# Created by our PEP3147 patch:
 	rm -f pypy/doc/config/objspace.magic_tag.txt
 	find . -name '*.pyc' -delete
-	rm -f pypy/translator/goal/pypy-c*
-	rm -f pypy/translator/cli/src/*.exe pypy/translator/cli/src/*.dll
+	find . -path '*/__pycache__/*' -delete
+	find . -name '__pycache__' -delete
+	rm -f pypy/goal/pypy-c*
+	rm -f pypy/test.db
+	rm -f rpython/translator/cli/src/*.exe rpython/translator/cli/src/*.dll
+	find rpython/translator/c -name '*.o' -delete
 	rm -f include/*.h include/*.inl
-	rm -rf pypy/_cache
+	rm -rf rpython/_cache
 	rm -f lib_pypy/ctypes_config_cache/_*_cache.py
 	rm -f $(filter-out %__init__.py, $(wildcard lib_pypy/ctypes_config_cache/_*_.py))
+	rm -rf pypy/module/test_lib_pypy/cffi_tests/snippets/*/build \
+	       pypy/module/test_lib_pypy/cffi_tests/snippets/*/dist \
+	       pypy/module/test_lib_pypy/cffi_tests/snippets/*/*.egg-info
 	rm -f lib-python/2.7/lib2to3/*Grammar*.pickle \
 	      pypy/module/test_lib_pypy/ctypes_tests/_ctypes_test.o \
 	      pypy/doc/config/commandline*.rst \
@@ -95,6 +104,7 @@
 	# Architecture-dependant bits of the stdlib (shipped in pypy)
 	find debian/pypy-lib/usr/lib/pypy/lib_pypy/ctypes_config_cache \
 	     \( -name '_*_.py' -a ! -name '__init__.py' \) -delete
+	rm -rf debian/pypy-lib/usr/lib/pypy/lib_pypy/__pycache__
 	# Architecture-dependant headers (shipped in pypy)
 	rm debian/pypy-dev/usr/lib/pypy/include/pypy_*.h
 
@@ -118,7 +128,7 @@
 	dh_compress -X.inv -X.txt
 
 override_dh_python2:
-	dh_python2 -p python-pypy.translator.sandbox
+	dh_python2 -p python-pypy.sandbox
 
 override_dh_builddeb:
 	dh_builddeb -- -Zxz
@@ -137,7 +147,7 @@
 endif
 	rm -rf pypy-$(VER).orig/.hg*
 	rm pypy-$(VER).orig/lib-python/*2.7/distutils/command/*.exe
-	rm pypy-$(VER).orig/pypy/translator/jvm/src/*.jar
+	rm pypy-$(VER).orig/rpython/translator/jvm/src/*.jar
 	tar -cJ --owner root --group root --mode a+rX \
 	    -f pypy_$(VER)+dfsg.orig.tar.xz pypy-$(VER).orig
 	rm -rf pypy-$(VER).orig
